var itemJSON_default = "./media/itemList.json";

var scenarioListJSON;

var itemListJSON;
var initialGridParent;
var itemGridParent;

var originalBudget = 0;
var budget = 0;
var totalSpend = 0;

var itemList = [];

var itemsToPrice = [];
var numberOfItemsToPrice = 8;

var totalItemsInShoppingBasket = 0;
var minItemsInShoppingBasket = 10;

var calculateBudgetChange = false;
var canUpdateTotalBudgetValue = false;

var progressBar;
var currentProgressStep = 0;
var totalProgressStep = 5;

var anElement;
var itemAnElement;

var currentItemGridDiv;

var pdfHeader;


/* Init
–––––––––––––––––––––––––––––––––––––––––––––––––– */
$(document).ready(function () {
	//initialGridParent = ".stage-needsAndWants .item-grid";
  initialGridParent = ".stage-needsAndWants .item-grid-container";
	progressBar = $('#progressBar');
	setProgress(0);

	updateBudgetDisplay();
	
	loadItemJSON(itemJSON_default);

	$( ".needWant-toggle input" ).checkboxradio({
    icon: false
  });

  buildResultsTable();
  

  /* Scenario Selection Clicks Transitions
  –––––––––––––––––––––––––––––––––––––––––––––––––– */
  addCustomBudgetInputEvent();

  $('.set-scenarios .pt-trigger').click(function() {
  	var scenarioCard = $(this);
  	selectSetScenario( $(scenarioCard).data("list"),$(scenarioCard).data("budget"), $(scenarioCard).find(".title").text(), $(scenarioCard).find(".helpText").html() );
  });

  $('.custom-scenarios .pt-trigger').click(function() {
   selectCustomScenario(budget, $('.custom-scenarios').find(".helpText").html());
 });

  //Stop the input field from triggering.
  $('.custom-scenarios .pt-trigger .budget-inputArea').click(function(event) {
  	event.stopPropagation();
  });
  
	/* Stage Transitions
  –––––––––––––––––––––––––––––––––––––––––––––––––– */
	//From Scenario
  $('.stage-scenarioSelection .pt-trigger').click(function() {
   showBudgetBar();
   setProgress(1);
 });

  //Back to Scenario
  $('.stage-needsAndWants .prevStageBtn').click(function() {
    //clear all item list info here.
    backToScenarios();
/*
    setProgress(0);
    hideBudgetBar();
    $("header h1").text("Supermarket Shopper");
    resetInstructionText();
    anElement.clear();
    $('.custom-scenarios .scenario').addClass("disabled");

    setTimeout(
    function() 
    {
      //$(oldItemGridDiv).empty();
      $(currentItemGridDiv).remove();
    }, 500);
*/

    });



	 //From needsAndWants
  $('.stage-needsAndWants .nextStageBtn').click(function() {
      goToTypical();
    });

    //Back to needsAndWants
    $('.stage-typical .prevStageBtn').click(function() {
      backToNeeds();
    });

    //From Typical
    $('.stage-typical .nextStageBtn').click(function() {
      goToPricing();
    });

    //Back to Typical
    $('.stage-pricing .prevStageBtn').click(function() {
      backToTypical();
    });

    //From Pricing
    $('.stage-pricing .nextStageBtn').click(function() {
      goToShopping();
    });

    //Back to Pricing
    $('.stage-shopping-2 .prevStageBtn').click(function() {
      backToPricing();
    });
    

    $(".needsAndWantsModal .stageNavBtn").on('click touchstart',function(){
     highlightUnselectedItems();
   });

    $(".pricingModal .stageNavBtn").on('click touchstart',function(){
     highlightUnpricedItems();
   });


    $(".shoppingModal .nextStageBtn").on('click touchstart',function(){
      buildResultsTable();
      buildFeedback();
      $('.shoppingModal .hiddenOpen').trigger( "click" );
    });
    
    $(".overviewListModal .downloadBtn").on('click',function(){
        downloadResultsTablePDF();
    });
    

    $(".resultsModal .nextStageBtn").on('click touchstart',function(){
      $(".overviewListModal .hiddenClose").trigger( "click" );
      $(".resultsModal .hiddenOpen").trigger( "click" );
      canUpdateTotalBudgetValue = true;
    });

    $(".extension1Btn").on('click',function(){
     changeBudgetByFactor(0.8)
     scrollToTopOfItems();
      $('.summaryModal .hiddenClose').trigger( "click" );

    });

    $(".extension1Btn .nextStageBtn").on('touchstart',function(){
       
     changeBudgetByFactor(0.8)
     scrollToTopOfItems();
      $('.summaryModal .hiddenClose').trigger( "click" );

    });

    $(".extension2Btn").on('click',function(){
     changeBudgetByFactor(1.2)
     scrollToTopOfItems();
      $('.summaryModal .hiddenClose').trigger( "click" );
    });

    $(".extension2Btn .nextStageBtn").on('touchstart',function(){
     changeBudgetByFactor(1.2)
     scrollToTopOfItems();
      $('.summaryModal .hiddenClose').trigger( "click" );
    });

    $(".resetBtn").on('click touchstart',function(){
     reset();
   });
    
  });

/* Progress bar
–––––––––––––––––––––––––––––––––––––––––––––––––– */

function setProgress(currentStep){
	currentProgressStep = currentStep;
	updateProgressBar();
}

function updateProgressBar(){

	var completeAmount =  (currentProgressStep / totalProgressStep)*100;
	animateProgressBar( (((currentProgressStep-1) / totalProgressStep)*100) ,completeAmount);
}

function animateProgressBar(prevAmount,amount){
	var width = prevAmount;
	var id = setInterval(frame, 10);

 function frame() {
   if (width >= amount) {
     clearInterval(id);
   } else {
     width++; 
     $(progressBar).width(width + '%');
   }
 }
}

/* Item list loading
–––––––––––––––––––––––––––––––––––––––––––––––––– */
function loadItemJSON(path){
	var jqxhr = $.getJSON( path, function(data) {
	  //console.log( "tolks:loadContentJSON - success" );
	  itemListJSON = data;
	})
 .done(function() {
	    //console.log( "second success" + itemListJSON.length);
	    buildItemListArray();
	  })
 .fail(function() {
   console.log( "JSON error" );
 })
 .always(function() {
	    //console.log( "complete" + itemListJSON.length);
	  }); 
}

function buildItemListArray(){
	var totalItemsCount = itemListJSON.length;

	itemList = [];

	for(var i = 0; i<totalItemsCount; i++){
		var item = createItemObject(itemListJSON[i]);
		itemList.push(item);
	}

	//printItemListArray();
	buildItemGrid();
	
}

function createItemObject(itemJSON){
	var item = new Object();

	item.name = itemJSON.name;
	item.imgPath = itemJSON.imgPath;
	item.defaultPrice = itemJSON.defaultPrice;
	item.typicalNeed = itemJSON.typicalNeed;
	item.inShoppingBasket = false;
	item.quantity = 0;

	return item;
}

function printItemListArray(){
	for(var i = 0; i < itemList.length; i++){
		console.log(itemList[i]);
	}
}

function buildItemGrid(){
	 //$(initialGridParent).empty();
   var itemGridHtml = '<div class="item-grid"></div>';

   if( $(initialGridParent).find(".item-grid").length){
   }
   else{
    $(initialGridParent).append(itemGridHtml);
   }

   itemGridParent = $(initialGridParent).find(".item-grid");
   $(itemGridParent).empty();

	for (var i = 0; i < itemList.length; i++) {
		$(itemGridParent).append(createItemCard(i,itemList[i]));
	}
	
	applyToggleButtonStylingAndEvents();
	checkAllItemNeedsAreSet();
  checkAllItemPricesAreSet(false);

  currentItemGridDiv = itemGridParent;
}

function copyItemGrid(targetDiv){
  var oldItemGridDiv = currentItemGridDiv;
  var newTarget =  targetDiv + " .gridBackgroundOffset";
  currentItemGridDiv = targetDiv + " .item-grid";
  $(oldItemGridDiv).clone().insertAfter(newTarget);

  setTimeout(
    function() 
    {
      //$(oldItemGridDiv).empty();
      $(oldItemGridDiv).remove();
    }, 1000);
  
}

/* use item info from itemList */
function createItemCard(itemIndex, item){
	var itemHtml = '<div class="item" data-index="'+ itemIndex +'">' +
  '<img src="'+item.imgPath+'"></img>' +
  '<h6 class ="title">'+item.name+'</h6>' +
  '<div class="needWant-toggle">'+
  '<fieldset><label class ="toggleLeft" for="radio-'+itemIndex+'-1">Need</label><input class="itemRadio" type="radio" name="radio-'+itemIndex+'" id="radio-'+itemIndex+'-1">'+
  '<label class ="toggleRight" for="radio-'+itemIndex+'-2">Want</label><input class="itemRadio" type="radio" name="radio-'+itemIndex+'" id="radio-'+itemIndex+'-2"></fieldset>' +
  '</div>' + 
  '<div class ="quantity">' +
  '<button class="quantityBtn" onclick="decreaseItemQuantity(this)"><i class="fas fa-minus"></i></button>' +
  '<h4 class = "quantityLabel">0</h4>' +
  '<button class="quantityBtn" onclick="increaseItemQuantity(this)"><i class="fas fa-plus"></i></button>' +
  '</div>' +
  '<div class="price-inputArea">' +
  '$ <input class="itemFormattedNumberField" type="text" placeholder="00.00"/>' +
  '</div>' +
  '<div class ="needWant-label"></div>' +
  '</div>';

  return $(itemHtml);
}

function applyToggleButtonStylingAndEvents(){
	$(".toggleLeft").addClass("ui-checkboxradio-label ui-corner-all ui-button ui-widget ui-checkboxradio-radio-label");
	$(".toggleRight").addClass("ui-checkboxradio-label ui-corner-all ui-button ui-widget ui-checkboxradio-radio-label");
	$(".itemRadio").addClass("ui-checkboxradio ui-helper-hidden-accessible");

	$('.needWant-toggle [type="radio"]').on('change', function() {

		var index = $(this).closest(".item").data("index");
		var radioName = $(this).attr('name');

		var radioValue = $('input[id="'+radioName+'-1"]:checked').val();
		if(radioValue){
			radioValue = true;
		}
		else{
			radioValue = false;
		}

		updateItemCurrentNeed(index,radioValue);

   $(this)
   .prev().addClass('ui-state-active')
   .siblings().removeClass('ui-state-active');

   if(itemList[index].typicalNeed == itemList[index].currentNeed){
    $(this).closest(".item").removeClass("differentFromTypical");
  }
  else{
    $(this).closest(".item").addClass("differentFromTypical");
  }

  $(this).closest(".item").removeClass("unselected");
});
}

/* 1 Scenario selection
–––––––––––––––––––––––––––––––––––––––––––––––––– */
function selectSetScenario(jsonURL, tempBudget, title, helpText){
	budget = parseFloat(tempBudget);
  originalBudget = budget;

  $("header h1").text(title);

  $(".instructionsModal .instructions").html(helpText.replace(/\n/g, "<br>"));

  loadItemJSON(jsonURL);
  updateBudgetDisplay();
    
    pdfHeader = "Supermarket Shopper | " + title;

}

function selectCustomScenario(tempBudget,helpText){
  $("header h1").text("Custom scenario");

  $(".instructionsModal .instructions").html(helpText.replace(/\n/g, "<br>"));

  loadItemJSON(itemJSON_default);
  updateBudgetDisplay();
}

function addCustomBudgetInputEvent(){
	var options = {
		minimumValue: "0",
    maximumValue: "1000000",
    watchExternalChanges: true
  }
  anElement = new AutoNumeric('.formattedNumberField',options);

  $( ".budget-inputArea input" ).change(function() {
    var budgetValue = $( this ).val();
    budget = parseFloat(budgetValue.replace(/,/g , '') );
    originalBudget = budget;

    if( (budget>0) && (budgetValue.length>0) ){
  			//can prodeed.
  			$('.custom-scenarios .scenario').removeClass("disabled");
  		}
  		else{
  			//can't proceed.
  			$('.custom-scenarios .scenario').addClass("disabled");
  		}
   });
}

function showBudgetBar(){	
	setTimeout(
    function() 
    {
      $("#budgetBar").removeClass("hidden");
    }, 500);
}

function hideBudgetBar(){
	$("#budgetBar").addClass("hidden");
}

/* 2 Needs and Wants
–––––––––––––––––––––––––––––––––––––––––––––––––– */

//For debugging
function DEBUG_forceCheckAllItemsNeeds(){
  for (var i = 0; i < itemList.length; i++) {
    updateItemCurrentNeed(i,true);
  }

  checkAllItemNeedsAreSet();
}
function backToScenarios(){
    setProgress(0);
    hideBudgetBar();
    $("header h1").text("Supermarket Shopper");
    resetInstructionText();
    anElement.clear();
    $('.custom-scenarios .scenario').addClass("disabled");

    setTimeout(
    function() 
    {
      $(currentItemGridDiv).empty();
    }, 500);
}

function updateItemCurrentNeed(itemIndex, setNeed){
	itemList[itemIndex].currentNeed = setNeed;
	checkAllItemNeedsAreSet();
}

function checkAllItemNeedsAreSet(){
	var allNeedsMet = true;

	for (var i = 0; i < itemList.length; i++) {
		if(itemList[i].currentNeed == null){
			allNeedsMet = false;
			break;
		}	
	}

	if(allNeedsMet){
    $('.stage-needsAndWants .nextStageBtn').show();
    $('.stage-needsAndWants .alertBtn').hide();
  }
  
  else{
    $('.stage-needsAndWants .nextStageBtn').hide();
    $('.stage-needsAndWants .alertBtn').show();

  }
}

function highlightUnselectedItems(){
  for (var i = 0; i < itemList.length; i++) {
    if(itemList[i].currentNeed == null){
      $(currentItemGridDiv).find(".item").eq(i).addClass("unselected");
    }
  }
}

function goToTypical(){
  copyItemGrid(".stage-typical");
  applyToggleButtonStylingAndEvents();
  setProgress(2);
}

/* 3 Typical needs
–––––––––––––––––––––––––––––––––––––––––––––––––– */
function backToNeeds(){
  copyItemGrid(".stage-needsAndWants");
  applyToggleButtonStylingAndEvents();
  setProgress(1);


}

function updateConfirmedNeed(){
  var currentNeedText = "Want";

  for (var i = 0; i < itemList.length; i++) {     
    if(itemList[i].currentNeed){
      currentNeedText = "Need";
      $(currentItemGridDiv).find(".item").eq(i).children(".needWant-label").addClass("need");
      $(currentItemGridDiv).find(".item").eq(i).children(".needWant-label").removeClass("want");
    }
    else{
      currentNeedText = "Want";
      $(currentItemGridDiv).find(".item").eq(i).children(".needWant-label").addClass("want");
      $(currentItemGridDiv).find(".item").eq(i).children(".needWant-label").removeClass("need");
    }
    $(currentItemGridDiv).find(".item").eq(i).children(".needWant-label").text(currentNeedText);
  } 
}

function goToPricing(){
  copyItemGrid(".stage-pricing");
  updateConfirmedNeed();
  chooseItemsToPrice();
  addPriceInputEvent();
  setProgress(3);
}

/* 4 Pricing
–––––––––––––––––––––––––––––––––––––––––––––––––– */

function backToTypical(){
  copyItemGrid(".stage-typical");
  applyToggleButtonStylingAndEvents();
  setProgress(2);
  showAllItems();
/*
  setTimeout(
    function() 
    {
      showAllItems();
    }, 500);
    */
}
/*
function copyItemGridToPricing(){
	$('.stage-shopping-1 .item-grid').clone().insertAfter( ".stage-pricing .gridBackgroundOffset");

	chooseItemsToPrice();
	addPriceInputEvent();

	setTimeout(
   function() 
   {
     $('.stage-shopping-1 .item-grid').empty();
   }, 1000);
	
}
*/

function chooseItemsToPrice(){
	itemsToPrice = [];
	//select items to price
	for(var i = 0; i < numberOfItemsToPrice; i++){
		itemsToPrice.push(getRandomUnselectedItem());
	}

	showSelectedItemsToPrice();
  checkAllItemPricesAreSet(false);
  removeHighlightAllItems();
}

function showSelectedItemsToPrice(){
  //hide all items 
  $('.stage-pricing .item-grid .item').hide();

  //show the selected items
  for (var i = 0; i < itemsToPrice.length; i++) {
    $('.stage-pricing .item-grid').find(".item").eq(itemsToPrice[i]).show();
  }
}

function getRandomUnselectedItem(){
	var randomNum = Math.floor(Math.random() * itemList.length);

	while(itemsToPrice.includes(randomNum)){
		randomNum = Math.floor(Math.random() * itemList.length);
	}

	return randomNum;
}

function addPriceInputEvent(){
  var options = {
    minimumValue: "0",
    maximumValue: "1000000"
  }

  itemAnElement = new AutoNumeric.multiple('.itemFormattedNumberField',options);


  $( ".price-inputArea input" ).change(function() {
    var itemCard = $(this).closest(".item");
    var index = $(itemCard).data("index");
    var priceValue = $( this ).val();

    itemList[index].setPrice = priceValue.replace(/,/g , '');

    if(priceValue != null){
      $(this).closest(".item").removeClass("unpriced");
    }

    checkAllItemPricesAreSet(true);
  });
}

function checkAllItemPricesAreSet(startingBool){
  var allPricesSet = startingBool;

  for (var i = 0; i < itemsToPrice.length; i++) {
    if( (itemList[itemsToPrice[i]].setPrice == null) || (itemList[itemsToPrice[i]].setPrice == "")){
      allPricesSet = false;
      break;
    } 
  }

  if(allPricesSet){
    $('.stage-pricing .nextStageBtn').show();
    $('.stage-pricing .alertBtn').hide();
  }
  
  else{
    $('.stage-pricing .nextStageBtn').hide();
    $('.stage-pricing .alertBtn').show();
  }
}

function removeHighlightAllItems(){
  for (var i = 0; i < itemList.length; i++) {
      $(currentItemGridDiv).find(".item").eq(i).removeClass("unpriced");
    
  }
}

function highlightUnpricedItems(){
  for (var i = 0; i < itemsToPrice.length; i++) {
    if( (itemList[itemsToPrice[i]].setPrice == null) || (itemList[itemsToPrice[i]].setPrice == "")){
      $(currentItemGridDiv).find(".item").eq(itemsToPrice[i]).addClass("unpriced");
    }
  }
}

function goToShopping(){
  copyItemGrid(".stage-shopping-2");
  setProgress(4);
  showAllItems();
/*
  setTimeout(
    function() 
    {
      showAllItems();
    }, 500);
    */
  //showAllItems();

  addPricesToItems();
  calculateBudgetChange = true;
  showCalculateBudgetBar();
  calculateTotalSpend();

  $('.stage-shopping-2 .container-scroller').animate({
    scrollTop: 0
  }, 0);
}


/* 5 Shopping phase
–––––––––––––––––––––––––––––––––––––––––––––––––– */

function backToPricing(){
  copyItemGrid(".stage-pricing");
  updateConfirmedNeed();
  showSelectedItemsToPrice();
  addPriceInputEvent();
  setProgress(3);
  hideCalculateBudgetBar();
}


function increaseItemQuantity(button){
  var itemCard = $(button).closest(".item");
  var index = $(itemCard).data("index");

  if(itemList[index].quantity<99){
    itemList[index].quantity++;


    $(itemCard).find(".quantityLabel").text(itemList[index].quantity);
  }

  $(itemCard).addClass("selected");

  if(!itemList[index].inShoppingBasket){
    itemList[index].inShoppingBasket = true;
    totalItemsInShoppingBasket++;
  }

  if(calculateBudgetChange){
    calculateTotalSpend();
  }
}

function decreaseItemQuantity(button){
  var itemCard = $(button).closest(".item");
  var index = $(itemCard).data("index");

  if(itemList[index].quantity>0){
    itemList[index].quantity--;

    $(itemCard).find(".quantityLabel").text(itemList[index].quantity);
  }

  if(itemList[index].quantity==0){
    if(itemList[index].inShoppingBasket){
      totalItemsInShoppingBasket--;
    }

    $(itemCard).removeClass("selected");
    itemList[index].inShoppingBasket = false;
  }

  if(calculateBudgetChange){
    calculateTotalSpend();
  }
}

function showCalculateBudgetBar(){
  $(".recalculateContainer").show();
  $(".remainingBudget").show();
  $('.providedBudget h2').text("BUDGET");


  
  $(".mainScreen").addClass("extendedMobileHeader");
}

function hideCalculateBudgetBar(){
  $(".recalculateContainer").hide();
  $(".remainingBudget").hide();
  $('.providedBudget h2').text("WEEKLY BUDGET");

  $(".mainScreen").removeClass("extendedMobileHeader");
}

//Need to show all of the items, some are hidden for the pricing phase.
/*
function copyItemGridToShopping_Phase2(){
	$('.stage-pricing .item-grid').clone().insertAfter( ".stage-shopping-2 .gridBackgroundOffset");

	setTimeout(
    function() 
    {
      showAllItems();
    }, 500);

	addPricesToItems();
	calculateBudgetChange = true;
	calculateTotalSpend();

	$('.stage-shopping-2 .container-scroller').animate({
    scrollTop: 0
  }, 0);

	setTimeout(
    function() 
    {
      $('.stage-pricing .item-grid').empty();
    }, 1000);
	
}
*/

function addPricesToItems(){
	for (var i = 0; i < itemList.length; i++) {

		//Now everything will have a set price to use for calculations.
		if( (itemList[i].setPrice == null) || (itemList[i].setPrice == "")){
			//itemList[i].setPrice = itemList[i].defaultPrice;
      itemList[i].finalPrice = itemList[i].defaultPrice;
		}
    else{
      itemList[i].finalPrice = itemList[i].setPrice;
    }	
   
		var currentNeedText = "Want";

		if(itemList[i].currentNeed){
			currentNeedText = "Need";
		}
		else{
			currentNeedText = "Want";
		}
		$('.stage-shopping-2 .item-grid').find(".item").eq(i).children(".needWant-label").text(currentNeedText + "  |  $" + itemList[i].finalPrice);
	}	
}

function showAllItems(){
	//$('.item-grid .item').show();
  $(currentItemGridDiv).find(".item").show();
}

function calculateTotalSpend(){
	var tempTotal = 0;

	for (var i = 0; i < itemList.length; i++) {
		tempTotal += (itemList[i].quantity * itemList[i].finalPrice);
	}

	totalSpend = tempTotal;
}

function updateBudgetDisplay(){
  $('.providedBudget h1').text( "$" + budget.toFixed(2) );
  $('.remainingBudget h1').text( "$" + (budget-totalSpend).toFixed(2) );
}

/* 6 Results
–––––––––––––––––––––––––––––––––––––––––––––––––– */
function buildResultsTable(){
  var table = $(".listSection").find("table");
  var thead = document.createElement("thead");
  var headRow = document.createElement("tr");
  var tbody = document.createElement("tbody");

  $(table).empty();

  //Table header Stuff
  ["Item","Quantity","Price"].forEach(function(el) {
    var th=document.createElement("th");
    th.appendChild(document.createTextNode(el));
    headRow.appendChild(th);
  });

  thead.appendChild(headRow);
  $(table).append(thead); 

  //Table body Stuff
  for (var i = 0; i < itemList.length; i++) {
    if(itemList[i].inShoppingBasket){
      var tr = document.createElement("tr");

      var calcTotalItemCost = "$"+((itemList[i].quantity * itemList[i].finalPrice).toFixed(2));

      [itemList[i].name,itemList[i].quantity,calcTotalItemCost].forEach(function(el) {
       var td = document.createElement("td");
       td.appendChild(document.createTextNode(el));
       tr.appendChild(td);
     });

      tbody.appendChild(tr);  
    }
  }
  $(table).append(tbody); 

}

function buildFeedback(){
  $('.overviewListModal .providedBudget').text("Provided budget: $" + (budget).toFixed(2));
  $('.overviewListModal .totalSpent').text("Total spent: $" + (totalSpend).toFixed(2));

  var budgetVariance = (budget-totalSpend);

  if(totalItemsInShoppingBasket >= minItemsInShoppingBasket){
    if(budgetVariance > 20){
      $('.feedbackSection h2').text("Great choices")
      $('.feedbackSection p').text("But you still have budget left to spend, maybe you can have another look at your “Wants”. Please go 'back' to change your shopping list or click ‘next’ to continue.  ")
    }
    else if(budgetVariance > 0){
      $('.feedbackSection h2').text("Great choices")
      $('.feedbackSection p').text("You have managed to stay within budget and get many of the items you needed on your shopping list. Click 'next' to continue.")
    }

    else{
      $('.feedbackSection h2').text("Your choices appear to be over budget.")
      $('.feedbackSection p').text("Please try again and concentrate on “Needs” rather than “Wants”. Please go 'back' to change your shopping list.")
    }
  }
  else{
      $('.feedbackSection h2').text("Your shopping list is quite empty")
      $('.feedbackSection p').text("You should try and make sure you have at least 10 items. Please go 'back' to change your shopping list.")
  }
}

function downloadResultsTablePDF(){
    
    var doc = new jsPDF({
            orientation: 'portrait'
        });

    var logoImg = new Image();
    logoImg.src = "img/SIS_Primary Logo_HR.png";
    
    doc.addImage(logoImg,'png',7,10,60,25);
    
    doc.autoTable({
        margin: { top: 40 },
        head: [[pdfHeader]],
        headStyles: {
                fillColor: [79, 41, 117],
                fontSize: 16,
                textColor: 255,
                fontStyle: 'bold',
                halign: 'center'
            }
    });
    
    doc.autoTable({
            html: '#shoppingListTable',

            styles: {
                font: 'Helvetica',
                fontSize: 12,
                rowPageBreak: 'auto'
            },

            headStyles: {
                fillColor: [255, 110, 50],
                fontSize: 12,
                textColor: 255,
                fontStyle: 'bold'
            },
        didParseCell: (data) => {
            if (data.column.index === 0) {
              data.cell.styles.cellWidth = 103;
              data.cell.styles.halign = 'left';
            }
            else if (data.column.index === 1) {
              data.cell.styles.cellWidth = 40;
              data.cell.styles.halign = 'center';
            }
            else if (data.column.index === 2) {
              data.cell.styles.cellWidth = 40;
              data.cell.styles.halign = 'center';
            }
        }
    });
    
     doc.autoTable({
        styles: {
                font: 'Helvetica',
                lineColor: [79, 41, 117],
                lineWidth: 0.55,
                cellWidth: 61
            },
        head: [['Provided Budget','Total Spent','Remaining Budget']],
        headStyles: {
                fillColor: [79, 41, 117],
                fontSize: 16,
                textColor: 255,
                fontStyle: 'bold',
                halign: 'center'
            },
         
        body:[["$" + (budget).toFixed(2),"$" + (totalSpend).toFixed(2),"$" + (budget-totalSpend).toFixed(2)]],
        bodyStyles: {
                fillColor: [255, 255, 255],
                fontSize: 12,
                textColor: 0,
                halign: 'center'
            },
    });
    
    doc.save('Supermarket-Shopper.pdf');
}

/* 9 Summary and Extensions
–––––––––––––––––––––––––––––––––––––––––––––––––– */

function scrollToTopOfItems(){
	$('.stage-shopping-2 .container-scroller').animate({
    scrollTop: 0
  }, 0);
}

function changeBudgetByFactor(factor){
  if(canUpdateTotalBudgetValue){
   canUpdateTotalBudgetValue = false;
	 budget = originalBudget * factor;
	 updateBudgetDisplay();
  }
}

function reset(){
  $(currentItemGridDiv).empty();
  $('.pt-wrapper nav .pt-trigger:nth-of-type(1)').trigger( "click" );

  hideBudgetBar();
  hideCalculateBudgetBar();
  setProgress(0);
  anElement.clear();
  $('.custom-scenarios .scenario').addClass("disabled");
  originalBudget = 0;
  budget = 0;
  totalSpend = 0;

  totalItemsInShoppingBasket = 0;
  canUpdateTotalBudgetValue = false;
  $("header h1").text("Supermarket Shopper");
  resetInstructionText();

  $('.stage-scenarioSelection .container-scroller').animate({
    scrollTop: 0
  }, 0);
}

function resetInstructionText(){
  var helpText = "Welcome to the Supermarket shop activity. Going supermarket shopping sounds easy, but having to stick to a budget means you can’t always have everything on your shopping list. In this activity you will have to decide whether you really need everything on your list, how much you need and if it’s a ‘want’ or a ‘need’.<br><br>You can do the activity in pairs or in groups. Please make sure you read the instructions carefully."
  $(".instructionsModal .instructions").html(helpText.replace(/\n/g, "<br>"));
}